#include <stdlib.h>
#include "headers/util.h"
#include "headers/bmp_reader.h"
#include "headers/bmp_writer.h"

void check_read_errors(const enum read_status status){
    switch (status)
    {
    case READ_INVALID_SIGNATURE:
        fprintf(stderr, "ERROR: Неверная сигнатура BMP\n");
        exit(22);
    case READ_INVALID_BITS:
        fprintf(stderr, "ERROR: Ошибка при чтении пикселей\n");
        exit(22);
    case READ_INVALID_HEADER:
        fprintf(stderr, "ERROR: Ошибка при чтении заголовка\n");
        exit(22);
    case READ_BIT_COUNT_ERROR:
        fprintf(stderr, "ERROR: Поддерживаются только 24-битные изображения\n");
        exit(22);
    case MEMORY_ALLOCATION_ERROR:
        fprintf(stderr, "ERROR: Ошибка выделения памяти\n");
        exit(12);
    default:
        printf("INFO: Файл успешно прочитан\n");
        break;
    }
}

void check_write_errors(enum write_status status){
    switch (status)
    {
    case WRITE_HEADER_ERROR:
        fprintf(stderr, "ERROR: Ошибка записи заголовка\n");
        exit(5);
    case WRITE_ERROR:
        fprintf(stderr, "ERROR: Ошибка записи\n");
        exit(5);
    default:
        printf("INFO: Файл сохранён\n");
        break;
    }
}

void check_open_errors(enum open_status status){
    switch (status)
    {
    case OPEN_ERROR:
        fprintf(stderr, "ERROR: Ошибка открытия файла\n");
        exit(2);
    
    default:
        printf("INFO: Файл открыт\n");
        break;
    }
}

void check_close_errors(enum close_status status){
    switch (status)
    {
    case CLOSE_ERROR:
        printf("WARN: Файл не был закрыт\n");
        break;
    
    default:
        printf("INFO: Файл успешно закрыт\n");
        break;
    }
}